<?php
ini_set('display_errors', 1);

require_once '../../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';
require_once $base_path_to_learning . 'admin_api/global_settings/template/template_function.php';
//aws image store
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";
require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;
$postdata = json_decode(file_get_contents("php://input"), true);
checkIfNoPhpContentsReceive();

if (
    // !isset($postdata['branch_id']) or !checkIfIssetAndNotEmpty($postdata['branch_id']) or
    !isset($postdata['class_id']) or !checkIfIssetAndNotEmpty($postdata['class_id']) or
    !isset($postdata['section_id']) or !checkIfIssetAndNotEmpty($postdata['section_id']) or
    // !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or 
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, ["teacher"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific,$version, $updated_time, $userid, $institution_id);


function getSpecificStudentCard($conn_rjllearning,$conn_rjllearning_specific,$institution_id,$branch_id,$class_id,$section_id) {
    
    $sql = $conn_rjllearning_specific->prepare("SELECT * FROM   student_id_cards where institution_id =? AND branch_id = ? AND class_id = ? AND section_id = ?");
    $sql->execute(array($institution_id,$branch_id,$class_id,$section_id));
    $rows = $sql->fetchAll();
    // print_r($rows);die();
    if (count($rows) >= 1) {
        
        $branch_info  = getBranchInfo($conn_rjllearning_specific, $institution_id, $rows[0]['branch_id']);
        $class_info = getClass($conn_rjllearning_specific, $institution_id, $rows[0]['class_id']);
        $section_info = getSection($conn_rjllearning_specific, $institution_id, $rows[0]['section_id']);

        $student_id = $rows[0]['student_id'];

        $students = []; // Initialize branches array

        if ($student_id == 'all') {

            $students[] = array('student_id' => $student_id, 'name' => ucwords($student_id));
        } else {
            // $imploded_branchids = implode(',', $branch_id); // Convert array to comma-separated string
            // print_R($imploded_branchids);
            $sql = "SELECT * FROM students WHERE institution_id = ? AND id IN ($student_id) ";
            $array_params = [$institution_id]; // Add institution_id to parameters
            $stmt = $conn_rjllearning_specific->prepare($sql);
            $stmt->execute($array_params);
            $student_results = $stmt->fetchAll();

            foreach ($student_results as $data) {
                $students[] = array('student_id' => $data['id'], 'name' => $data['name']);
            }
        }
        
        $data_printed[] = json_decode($rows[0]['data_printed'], true);
        $template_info = getSpecificPrintTemplate($conn_rjllearning,$rows[0]['selected_template']);
        
        return array('cards_id'=> $rows[0]['id'],'branch_id'=>$branch_info ,'class_info'=> $class_info,'section_info'=> $section_info,
        'student_id'=> $students,'selected_template'=> $template_info, 'data_printed' => $data_printed);
      
    }else{
          errorreturn("Enter Invalid Student Card info.");
    }

}

if($postdata['function_type']  == "fetch_specific_student_cards") {  
    
    // $institution_id = trim($postdata['institution_id']); 
    // $branch_id = trim($postdata['branch_id']);
    $class_id = trim($postdata['class_id']);
    $section_id = trim($postdata['section_id']);
    $teacher_data = getClassSectionSubjectsAndInChargeRoles($conn_rjllearning, $conn_rjllearning_specific, $institution_id, $userid);
    $class_section_subjects  = $teacher_data['class_section_subjects'];
    $class_incharge_roles = $teacher_data['class_incharge_roles'];
    $staff_access_modules = $teacher_data['staff_access_modules'];
    $check_faculty_status = checkFacultyModuleGranted('fetch_student_cards', $class_section_subjects, $class_incharge_roles, $staff_access_modules, $class_id, $section_id, null, $conn_rjllearning);
    if($check_faculty_status == false){
        errorreturn("Access denied: You do not have the required permissions.");
    }
    
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific,$institution_id);
    if($check_academic_confirmation != true){
         errorreturn("Access denied. Academic session not active.");
    }
    $success['data'] = getSpecificStudentCard($conn_rjllearning,$conn_rjllearning_specific,$institution_id,$branch_id,$class_id,$section_id);
    successreturn($success);
}

